Please note that starting from June 1, Google Ad Traffic By Keywords returns bulk data for the entire campaign (all keywords specified when setting a task). You can learn more in this update.
Using the Ad Traffic By Keywords endpoint, you can receive a set of stats for estimating CPC, and clicks. This data is really useful for estimating real demand for a specific keyword, as it is much more accurate than the regular search volume information, which shows the broad match estimation for a group of similar keywords.
GET
Pricing
Your account will be charged only for posting a task. You can get the results of the task within the next 30 days for free.
The cost can be calculated on the Pricing page.
Description of the fields for sending a request:
Field name
Type
Description
id
string
task identifier unique task identifier in our system in the UUID format you will be able to use it within 30 days to request the results of the task at any time
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.
Description of the fields in the result array:
Field name
Type
Description
version
string
the current version of the API
status_code
integer
general status code you can find the full list of the response codes here Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions
status_message
string
general informational message you can find the full list of general informational messages here
time
string
execution time, seconds
cost
float
total tasks cost, USD
tasks_count
integer
the number of tasks in the tasks array
tasks_error
integer
the number of tasks in the tasks array returned with an error
tasks
array
array of tasks
id
string
task identifier unique task identifier in our system in the UUID format
status_code
integer
status code of the task generated by DataForSEO; can be within the following range: 10000-60000 you can find the full list of response codes here
status_message
string
informational message of the task you can find the full list of general informational messages here
time
string
execution time, seconds
cost
float
cost of the task, USD
result_count
integer
number of elements in the result array
path
array
URL path
data
object
contains the same parameters that you specified in the POST request
result
array
array of results
keyword
string
keyword in a POST array metrics are provided for all the keywords specified in the POST array
location_code
integer
location code in a POST array if there is no data, then the value is_nulln
language_code
string
language code in a POST array if there is no data, then the value is_nulln
date_interval
string
forecasting date interval in a POST array
search_partners
boolean
include Google search partners the value is always false
bid
float
the maximum custom bid the bid you have specified when setting the task represents the price you are willing to pay for an ad the higher value you have specified, the higher metrics and cost you receive in response learn more in this help center article
match
string
keywords match-type can take the following values: exact, broad, phrase
impressions
float
projected number of ad impressions number of impressions an ad is projected to get within the specified time period Note: parameter deprecated, the value is always_nulln
ctr
float
projected clickthrough rate (CTR) of the advertisement number of clicks an ad is projected to receive divided by the number of ad impressions; Note: parameter deprecated, the value is always null
average_cpc
float
the average cost-per-click value represents the cost-per-click (USD) estimated for a keyword based on the specified time period and historical data; if there is no data, then the value is_nulln
cost
float
charge for an ad amount that will be charged for running an ad within the specified time period if there is no data, then the value is_nulln
clicks
float
number of clicks on an ad number of clicks an ad is projected to get within the specified time period if there is no data, then the value is_nulln
Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
login="login"
password="password"
cred="$(printf ${login}:${password} | base64)"
id="02031634-0696-0111-0000-61c2471b87fc"
curl --location --request GET "https://api.dataforseo.com/v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/${id}"
--header "Authorization: Basic ${cred}"
--header "Content-Type: application/json"
--data-raw ""
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
echo "n";
print "HTTP code: {$e->getHttpCode()}n";
print "Error code: {$e->getCode()}n";
print "Message: {$e->getMessage()}n";
print $e->getTraceAsString();
echo "n";
exit();
}
try {
$result = array();
// #1 - using this method you can get a list of completed tasks
// the full list of possible parameters is available in documentation
// GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/tasks_ready
$tasks_ready = $client->get('/v3/keywords_data/google_ads/ad_traffic_by_keywords/tasks_ready');
// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if (isset($tasks_ready['status_code']) AND $tasks_ready['status_code'] === 20000) {
foreach ($tasks_ready['tasks'] as $task) {
if (isset($task['result'])) {
foreach ($task['result'] as $task_ready) {
// #2 - using this method you can get results of each completed task
// GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/$id
if (isset($task_ready['endpoint'])) {
$result[] = $client->get($task_ready['endpoint']);
}
// #3 - another way to get the task results by id
// GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/$id
/*
if (isset($task_ready['id'])) {
$result[] = $client->get('/v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/' . $task_ready['id']);
}
*/
}
}
}
}
print_r($result);
// do something with result
} catch (RestClientException $e) {
echo "n";
print "HTTP code: {$e->getHttpCode()}n";
print "Error code: {$e->getCode()}n";
print "Message: {$e->getMessage()}n";
print $e->getTraceAsString();
echo "n";
}
$client = null;
?>
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
# 1 - using this method you can get a list of completed tasks
# in addition to 'ad_traffic_by_keywords' you can also set other parameters
# the full list of possible parameters is available in documentation
# GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/tasks_ready
response = client.get("/v3/keywords_data/google_ads/ad_traffic_by_keywords/tasks_ready")
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response['status_code'] == 20000:
results = []
for task in response['tasks']:
if (task['result'] and (len(task['result']) > 0)):
for resultTaskInfo in task['result']:
# 2 - using this method you can get results of each completed task
# GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/$id
if(resultTaskInfo['endpoint']):
results.append(client.get(resultTaskInfo['endpoint']))
'''
# 3 - another way to get the task results by id
# GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/$id
if(resultTaskInfo['id']):
results.append(client.get("/v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/" + resultTaskInfo['id']))
'''
print(results)
# do something with result
else:
print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemos
{
public static partial class Demos
{
public static async Task keywords_data_task_get()
{
var httpClient = new HttpClient
{
BaseAddress = new Uri("https://api.dataforseo.com/"),
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
};
// #1 - using this method you can get a list of completed tasks
// in addition to 'ad_traffic_by_keywords' you can also set other parameters
// the full list of possible parameters is available in documentation
// GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/tasks_ready
var response = await httpClient.GetAsync("/v3/keywords_data/google_ads/ad_traffic_by_keywords/tasks_ready");
var tasksInfo = JsonConvert.DeserializeObject<dynamic>(await response.Content.ReadAsStringAsync());
var tasksResponses = new List<object>();
// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if (tasksInfo.status_code == 20000)
{
if (tasksInfo.tasks != null)
{
foreach (var tasks in tasksInfo.tasks)
{
if (tasks.result != null)
{
foreach (var task in tasks.result)
{
if (task.endpoint != null)
{
// #2 - using this method you can get results of each completed task
// GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/$id
var taskGetResponse = await httpClient.GetAsync((string)task.endpoint);
var taskResultObj = JsonConvert.DeserializeObject<dynamic>(await taskGetResponse.Content.ReadAsStringAsync());
if (taskResultObj.tasks != null)
{
var fst = taskResultObj.tasks.First;
// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if (fst.status_code >= 40000 || fst.result == null)
Console.WriteLine($"error. Code: {fst.status_code} Message: {fst.status_message}");
else
tasksResponses.Add(fst.result);
}
// #3 - another way to get the task results by id
// GET /v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/$id
/*
var tasksGetResponse = await httpClient.GetAsync("/v3/keywords_data/google_ads/ad_traffic_by_keywords/task_get/" + (string)task.id);
var taskResultObj = JsonConvert.DeserializeObject<dynamic>(await tasksGetResponse.Content.ReadAsStringAsync());
if (taskResultObj.tasks != null)
{
var fst = taskResultObj.tasks.First;
// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if (fst.status_code >= 40000 || fst.result == null)
Console.WriteLine($"error. Code: {fst.status_code} Message: {fst.status_message}");
else
tasksResponses.Add(fst.result);
}
*/
}
}
}
}
}
if (tasksResponses.Count > 0)
// do something with result
Console.WriteLine(String.Join(Environment.NewLine, tasksResponses));
else
Console.WriteLine("No completed tasks");
}
else
Console.WriteLine($"error. Code: {tasksInfo.status_code} Message: {tasksInfo.status_message}");
}
}
}
The above command returns JSON structured like this: